<?php

/**
 * Implements hook_field_views_data().
 */
function questions_field_field_views_data($field) {
  $data = field_views_field_default_views_data($field);
  $components = questions_field_field_components_load($field);
  if(!empty($components)){
//   Add a filter handler for select component.
  $key = key($field['storage']['details']);
  foreach ($field['storage']['details'][$key] as $type => $tables) {
    foreach ($tables as $table_name => $columns) {
        foreach($columns as $cid => $column_real_name){ 
           if ($components[$cid]['type'] != 'select') {
             continue;
          }
          
        if (!isset($data[$table_name][$column_real_name]['filter'])) {
          continue;
        }
      
      $data[$table_name][$column_real_name]['filter']['handler'] = 'questions_field_views_handler_filter_select';
     }
    }
  }

  // Only expose these components as Views field handlers.
  foreach($components as $cid => $component){
    if($component['type'] == 'select')  $implemented[$cid] = 'questions_field_views_handler_field_select'; 
      else $implemented[$cid] = 'questions_field_views_handler_field';  
  }

  // Get the translated field information.
  $properties = questions_field_data_property_info($field);

  // Iterate over Questions field defined tables.
  foreach ($data as &$table) {
    // Make sure the parent Views field (questions field) is defined.
    if (isset($table[$field['field_name']]['field'])) {
      // Use the parent field definition as a template for component columns.
      $field_def = $table[$field['field_name']]['field'];

      // Remove 'additional fields' from the field definition. We don't
      // necessarily want all our sibling columns.
      unset($field_def['additional fields']);

      // Define the valid columns.
      $valid_columns = array();
      foreach ($implemented as $implement => $handler) {
        $column_name = $field['field_name'] . '_' . $implement;
        $valid_columns[$column_name] = $handler;
      }

      // Iterate over the Questions field components.
      foreach ($table as $column_name => &$column) {
        if (empty($column['field']) && isset($valid_columns[$column_name])) {
          // Assign the default component definition.
          $column['field'] = $field_def;
          $column['field']['real field'] = $column_name;
          $column['field']['handler'] = $valid_columns[$column_name];

          // Assign human-friendly field labels for Questions field components.
          $field_labels = field_views_field_label($field['field_name']);
          $field_label = array_shift($field_labels);
          $property = str_replace($field_def['field_name'] . '_', '', $column_name);

          if (!empty($properties[$property])) {
            $property_label = $properties[$property]['label'];

            $title = t('@field-label - @property-label', array(
              '@field-label' => $field_label,
              '@property-label' => $property_label,
            ));

            $column['title'] = $title;
            $column['title short'] = $title;
          }
        }
      }
    }
  }
  }
  return $data;
}
