<?php
//views_handler_field_field

 
class questions_field_views_handler_field extends views_handler_field{

  function option_definition() {
    $options = parent::option_definition();
    $options['display_question'] = array('default' => 0);
    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $form['display_question'] = array(
      '#type' => 'checkbox',
      '#title' => t('Hide the Question of this component'),
      '#default_value' => $this->options['display_question'],
      '#return_value' => 'none',

    );
  }
  
  
  function get_base_table() {
    if (!isset($this->base_table)) {
      // This base_table is coming from the entity not the field.
      $this->base_table = $this->view->base_table;

      // If the current field is under a relationship you can't be sure that the
      // base table of the view is the base table of the current field.
      // For example a field from a node author on a node view does have users as base table.
      if (!empty($this->options['relationship']) && $this->options['relationship'] != 'none') {
        $relationships = $this->view->display_handler->get_option('relationships');
        if (!empty($relationships[$this->options['relationship']])) {
          $options = $relationships[$this->options['relationship']];
          $data = views_fetch_data($options['table']);
          $this->base_table = $data[$options['field']]['relationship']['base'];
        }
      }
    }

    return $this->base_table;
  }
  
  /**
   * Load complete component with data field and instance
   */
  function load_component($values){
         $this->get_base_table();
        // Get the entity type according to the base table of the field.
        $entity_type = $this->definition['entity_tables'][$this->base_table];
        $entity_info = entity_get_info($entity_type);
        // We always need the base field (entity_id / revision_id).
        if (empty($this->definition['is revision'])) {
            $field_alias = $entity_info['entity keys']['id'];
        } else {
            $field_alias = $entity_info['entity keys']['revision'];
        }
        $field = field_info_field($this->definition['field_name']);
        $entity = $values->_field_data[$field_alias]['entity'];
        list(,, $bundle_name) = entity_extract_ids($entity_type, $entity);
        $instance = field_info_instance($entity_type, $this->definition['field_name'], $bundle_name);
        $cid = str_replace($field['field_name'] . '_', '', $this->field);
       return _questions_field_get_component_from_field_single($field, $instance, $cid);     
  }
  
  function render_component($values) {
        $value = $this->get_value($values);
        $component = $this->load_component($values);
        $component['extra']['title_display'] = ($this->options['display_question']) ? $this->options['display_question'] : $component['extra']['title_display'] ;
        return questions_field_component_invoke($component['type'], 'display', $component, $value);
}

    /**
   * Render the field.
   *
   * @param $values
   *   The values retrieved from the database.
   */
  function render($values) {
   return $this->render_component($values);
  }
  
}

